#!python

import sys
import os

sys.path.append(os.path.realpath(__file__))

import time

import schedule

from stats_lib.data_store import InfluxDb, DebugPrintDataStore
from stats_lib.providers.givenergy import GivEnergy
from stats_lib.providers.solar_edge import SolarEdge
from stats_lib.providers.octopus_energy import OctopusEnergy
from stats_lib.providers.weather_api import WeatherAPI


#data_store = DebugPrintDataStore()
data_store = InfluxDb()

solar_edge = SolarEdge()
#octopus_energy = OctopusEnergy()
givenergy = GivEnergy()
weather_api = WeatherAPI()

# site_power = solar_edge.get_site_power_details(
#     datetime.timedelta(minutes=1),
#     datetime.timedelta(minutes=60)
# )
# power_flow = solar_edge.get_power_flow()
#print(solar_edge.get_inverter_technical_data(datetime.timedelta(minutes=360)))

schedule.every(5).minutes.do(lambda: data_store.store_values(weather_api.get_current_weather()))

schedule.every(30).seconds.do(lambda: data_store.store_values(givenergy.get_data_points()))
schedule.every(30).seconds.do(lambda: data_store.store_values(givenergy.get_energy_flow()))

schedule.every().hour.do(lambda: data_store.store_values(solar_edge.get_environment_benefits()))

while True:
    schedule.run_pending()
    time.sleep(1)
