
import datetime


class DataPoint:

    def __init__(self, key, value, timestamp=None):
        """Data point to insert into database"""
        self._timestamp = datetime.datetime.now() if timestamp is None else timestamp
        self._key = key
        self._value = value

    @property
    def key(self):
        """Return key"""
        return self._key

    @property
    def value(self):
        """Return value"""
        return self._value

    @property
    def timestamp(self):
        """Return timestamp"""
        return self._timestamp
