
import datetime

from stats_lib.frame_buffer import FrameBuffer


class BaseDisplay:
    """Default display for showing constant data"""

    SHOW_IN_ROTATION = True

    def __init__(self, data_source):
        """Create framebuffer"""
        self._framebuffer = FrameBuffer()
        self._data_source = data_source

    def draw(self):
        """Draw display"""
        today = datetime.date.today()
        if today.month == 12 and today.day == 25:
            self._framebuffer.text("Merry Christmas!!", (20, 30), font_size=40)
        else:
            # Draw total cost today
            self._framebuffer.text("Cost Today: £TBC", (20, 30), font_size=40)

    def to_byte_array(self, line_number):
        """Return byte array of frambuffer"""
        return self._framebuffer.to_byte_array(line_number)
