
from stats_lib.display.base_display import BaseDisplay


class EnergyFlowDisplay(BaseDisplay):
    """Show energy flow data"""

    SHOW_IN_ROTATION = False

    def draw(self):
        """Draw"""
        # Show default items
        super().draw()

        # Left-hand column
        self._framebuffer.text("Today's costs", (20, 100))
        self._framebuffer.text("Electricity: £TBC", (20, 140))
        self._framebuffer.text("Gas: £TBC", (20, 180))
        self._framebuffer.text(f"Current usage: {round(self._data_source.get_latest_value('usage_consumption_w', default=0), 2)}W", (20, 220))
        self._framebuffer.text(f"Generating: {round(self._data_source.get_latest_value('solar_power_w', default=0), 2)}W", (20, 260))
        self._framebuffer.text(f"Battery Charge: {self._data_source.get_latest_value('battery_charge_perc')}%", (20, 300))

        self._framebuffer.text(f"Flow Today", (420, 100))
        consumed = (
            self._data_source.get_latest_value("grid_to_home_kw", default=0.0) +
            self._data_source.get_latest_value("pv_to_home_kw", default=0.0)
        )
        self._framebuffer.text(f"Consumed: {round(consumed, 2)}KW", (420, 140))

        pv_generated = (
            self._data_source.get_latest_value("pv_to_home_kw", default=0.0) +
            self._data_source.get_latest_value("pv_to_battery_kw", default=0.0) +
            self._data_source.get_latest_value("pv_to_grid_kw", default=0.0)
        )
        self._framebuffer.text(f"Generated: {round(pv_generated, 2)}KW", (420, 180))
        from_grid = (
            self._data_source.get_latest_value("grid_to_home_kw", default=0) +
            self._data_source.get_latest_value("grid_to_battery_kw", default=0)
        )
        self._framebuffer.text(f"From grid: {round(from_grid, 2)}KW", (420, 220))
