

from stats_lib.display.base_display import BaseDisplay
# Import all displays to be used
from stats_lib.display.energy_flow import EnergyFlowDisplay
from stats_lib.display.energy_flow_diagram import EnergyFlowDiagramDisplay
from stats_lib.display.weather_today import WeatherToday
from stats_lib.display.zen_quote import ZenQuote
# from stats_lib.display.solar_stats import SolarStats
from stats_lib.display.upcoming_events import UpcomingEvents
from stats_lib.display.news_article import NewsArticle


class DisplayFactory:

    def __init__(self, data_source):
        """Store member variables"""
        self._data_source = data_source
        self._current_display_itx = 0
        self._all_display_classes = [
            display_class
            for display_class in BaseDisplay.__subclasses__()
            if display_class.SHOW_IN_ROTATION
        ]
        self._display_classes_count = len(self._all_display_classes)

    def get_next_display(self):
        """Return next display"""
        display = self._all_display_classes[self._current_display_itx](data_source=self._data_source)
        display.draw()

        print("Serving dislay", display.__class__.__name__)

        self._current_display_itx += 1
        if self._current_display_itx == self._display_classes_count:
            self._current_display_itx = 0
        return display
