
import os
import requests

from stats_lib.display.base_display import BaseDisplay
from stats_lib.providers.world_news_api import WorldNewsApi
from stats_lib.utils import print_debug


class NewsArticle(BaseDisplay):
    """News Artcile display"""

    SHOW_IN_ROTATION = False

    # Cache of news articles, which will be cycled through
    # before obtaining new articles from API
    NEWS_ARTICLES = []

    @classmethod
    def _get_article(cls):
        """Obtain an article, re-obtaining from API if necessary"""

        if not cls.NEWS_ARTICLES:
            cls.NEWS_ARTICLES = WorldNewsApi().get_news_articles()

        return cls.NEWS_ARTICLES.pop(0)['title']

    def draw(self):
        """Draw"""
        try:
            article = self._get_article() or "Could not obtain news article"
            print_debug("Got article", article)
            self._framebuffer.text("Latest News", (320, 40))
            self._framebuffer.text(
                article,
                (40, 100),
                split_multiline=True,
                max_width=600)
        except:
            pass
