
import requests

from stats_lib.display.base_display import BaseDisplay


class ZenQuote(BaseDisplay):
    """Zen quote display"""

    SHOW_IN_ROTATION = False

    def draw(self):
        """Draw"""
        try:
            res = requests.get(
                "https://zenquotes.io/api/today",
                headers={
                    "Content-Type": "application/json",
                    "Accept": "application/json"
                }
            )
            quote = res.json()[0]
            self._framebuffer.text("Zen Quote", (320, 40))
            end_y = self._framebuffer.text(
                quote.get('q'),
                (40, 100),
                split_multiline=True,
                max_width=600)
            self._framebuffer.text(f" - {quote.get('a')}", (80, end_y))
        except:
            pass
