
import datetime


class Stats:

    def __init__(self, data_store):
        """Store data store"""
        self._data_store = data_store

    def get_energy_usage_generation_per_day(self):
        """Get energy generation amounts per day"""
        all_data = {}
        for data_type in ["pv_to_home_kw", "battery_to_home_kw", "pv_to_battery_kw"]:

            all_data_points = self._data_store.get_all_values(data_type)
            last_item = None
            for itx, data_point in enumerate(all_data_points):
                data_point['dt'] = datetime.datetime.fromisoformat(data_point['time'].replace('Z', ''))
                if last_item is not None:
                    # If current data point is a new date, print the data
                    if last_item['dt'].date != data_point['dt'].date or itx == (len(all_data_points) - 1):

                        date = last_item['dt'].date().isoformat()
                        if date not in all_data:
                            all_data[date] = {}
                        all_data[date][data_type] = last_item['value']

                last_item = data_point

        return all_data
